package com.jtricks;

import webwork.action.Action;
import webwork.action.ActionContext;

import com.atlassian.jira.bc.issue.IssueService;
import com.atlassian.jira.issue.IssueFactory;
import com.atlassian.jira.web.action.issue.CreateIssueDetails;
import com.atlassian.jira.web.action.issue.IssueCreationHelperBean;

public class MyCreateIssueDetails extends CreateIssueDetails{

	public MyCreateIssueDetails(IssueFactory issueFactory, IssueCreationHelperBean issueCreationHelperBean, IssueService issueService) {
		super(issueFactory, issueCreationHelperBean, issueService);
		// TODO Auto-generated constructor stub
	}
	
	@Override
	protected void doValidation() {
		//My custom validation here
		String assignee = getSingleValueFromParameters("assignee");
		if (assignee == null || !assignee.equals(getRemoteUser().getName())){
			addErrorMessage("Assignee is not the current user, got U!");
		}
		super.doValidation();
	}
	
	@Override
	protected String doExecute() throws Exception {
		String ret_val  = super.doExecute();
		if (!ret_val.equals(Action.ERROR)){
			postCreationTasks();
		}
		return ret_val;
	}

	private void postCreationTasks() {
		System.out.println("Doing my crazy stuff here!");
	}
	
	private String getSingleValueFromParameters(String key)
    {
        final String[] strings = (String[]) ActionContext.getParameters().get(key);
        if (strings != null && strings.length == 1)
        {
            return strings[0];
        }
        return null;
    }

}
